SystemOrganization addCategory: #MkAgario!

PackageManifest subclass: #ManifestMkAgario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MkAgario'!

!ManifestMkAgario commentStamp: '<historical>' prior: 0!
I store metadata for this package. These meta data are used by other tools such as the SmalllintManifestChecker and the critics Browser!

!ManifestMkAgario class methodsFor: 'code-critics' stamp: 'MathiasKegelmann 9/22/2018 16:11'!
ruleRBInconsistentMethodClassificationRuleV1FalsePositive
	^ #(#(#(#RGPackage #(#MkAgario)) #'2018-09-22T16:11:03.825+02:00') )! !

Morph subclass: #AgarioGame
	instanceVariableNames: 'pellets players'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MkAgario'!

AgarioGame class
	instanceVariableNames: 'players pellets'!

AgarioGame class
	instanceVariableNames: 'players pellets'!

!AgarioGame methodsFor: 'private ' stamp: 'MathiasKegelmann 9/22/2018 17:03'!
actors
	^ pellets, players! !

!AgarioGame methodsFor: 'stepping' stamp: 'MathiasKegelmann 9/22/2018 18:56'!
doesPellet: aPellet touchPlayer: aPlayer
	^ (aPellet position distanceTo: aPlayer position) < (aPellet radius + aPlayer radius)! !

!AgarioGame methodsFor: 'drawing' stamp: 'MathiasKegelmann 9/22/2018 16:59'!
drawOn: aCanvas
	| offset |
	aCanvas fillRectangle: self bounds fillStyle: self fillStyle borderStyle: self borderStyle.
	offset := self position.
	self actors do: [ :each | each drawOn: aCanvas withOffset: offset ].! !

!AgarioGame methodsFor: 'stepping' stamp: 'MathiasKegelmann 9/22/2018 19:03'!
eatPellets
	pellets copy
		do: [ :aPellet | 
			aPellet
				touchPlayers: (players select: [ :aPlayer | self doesPellet: aPellet touchPlayer: aPlayer ])
				inGame: self ]! !

!AgarioGame methodsFor: 'event-handling' stamp: 'MathiasKegelmann 9/22/2018 17:49'!
handleKeystroke: e
	| k |
	k := e keyValue asCharacter.
	players do: [ :each | each handleKey: k ].

! !

!AgarioGame methodsFor: 'event-handling' stamp: 'MathiasKegelmann 9/22/2018 17:08'!
handlesMouseOver: e
	^true! !

!AgarioGame methodsFor: 'instance creation' stamp: 'MathiasKegelmann 9/22/2018 16:58'!
initialize
	super initialize.
	self extent: 500@500;
		color: Color white.
	pellets := OrderedCollection new.
	players := OrderedCollection with: AgarioPlayer new.
	100 timesRepeat:  [ pellets add: AgarioPellet new ]! !

!AgarioGame methodsFor: 'event-handling' stamp: 'MathiasKegelmann 9/22/2018 17:09'!
mouseEnter: e
	e hand newKeyboardFocus: self! !

!AgarioGame methodsFor: 'event-handling' stamp: 'MathiasKegelmann 9/22/2018 17:09'!
mouseLeave: e
	e hand newKeyboardFocus: nil! !

!AgarioGame methodsFor: 'stepping' stamp: 'MathiasKegelmann 9/22/2018 18:01'!
moveActors
	players do: [ :each | each move ]! !

!AgarioGame methodsFor: 'instance creation' stamp: 'MathiasKegelmann 9/22/2018 16:55'!
open
	self openInWindowLabeled: 'Agario';
		yourself ! !

!AgarioGame methodsFor: 'action' stamp: 'MathiasKegelmann 9/22/2018 18:51'!
remove: aPellet
	pellets remove: aPellet! !

!AgarioGame methodsFor: 'drawing' stamp: 'MathiasKegelmann 9/22/2018 16:51'!
showOn: aCanvas
	! !

!AgarioGame methodsFor: 'stepping' stamp: 'MathiasKegelmann 9/22/2018 18:01'!
step
	self moveActors;
		eatPellets;
	changed! !

!AgarioGame methodsFor: 'stepping' stamp: 'MathiasKegelmann 9/22/2018 17:50'!
stepTime
	^ 10! !

Object subclass: #AgarioPellet
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MkAgario'!

AgarioPellet class
	instanceVariableNames: 'position'!

AgarioPellet class
	instanceVariableNames: 'position'!

!AgarioPellet methodsFor: 'drawing' stamp: 'MathiasKegelmann 9/22/2018 19:19'!
drawOn: aCanvas withOffset: aPoint
	aCanvas fillOval: (Rectangle center: position + aPoint extent: 6 @ 6) color: Color blue! !

!AgarioPellet methodsFor: 'initialization' stamp: 'MathiasKegelmann 9/22/2018 16:57'!
initialize
	| r |
	r := Random new.
	position := (r nextInt: 500) @ (r nextInt: 500).
! !

!AgarioPellet methodsFor: 'accesing' stamp: 'MathiasKegelmann 9/22/2018 18:40'!
position
	^position! !

!AgarioPellet methodsFor: 'accesing' stamp: 'MathiasKegelmann 9/22/2018 19:19'!
radius
	^ 3! !

!AgarioPellet methodsFor: 'action' stamp: 'MathiasKegelmann 9/22/2018 19:20'!
touchPlayers: aPlayerCollection inGame: aGame
	aPlayerCollection isEmpty
		ifTrue: [ ^ self ].
	(aPlayerCollection at: 1) gainNutrients: 2.
	aGame remove: self! !

Object subclass: #AgarioPlayer
	instanceVariableNames: 'position direction speed radius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MkAgario'!

!AgarioPlayer methodsFor: 'drawing' stamp: 'MathiasKegelmann 9/22/2018 19:18'!
drawOn: aCanvas withOffset: aPoint
	aCanvas fillOval: (Rectangle center: position + aPoint extent: (2 * radius) @ (2 * radius)) color: Color red! !

!AgarioPlayer methodsFor: 'actions' stamp: 'MathiasKegelmann 9/22/2018 18:50'!
gainNutrients: amount
	radius := radius + amount! !

!AgarioPlayer methodsFor: 'initialization' stamp: 'MathiasKegelmann 9/22/2018 17:50'!
handleKey: aKey
	(aKey = $w) ifTrue: [ direction := 0@(-1) ]. 
	(aKey = $a) ifTrue: [ direction := (-1)@0 ]. 
	(aKey = $d) ifTrue: [ direction := 1@0 ]. 
	(aKey = $x) ifTrue: [ direction := 0@1 ].
! !

!AgarioPlayer methodsFor: 'initialization' stamp: 'MathiasKegelmann 9/22/2018 17:57'!
initialize
	| r |
	r := Random new.
	position := (r nextInt: 500) @ (r nextInt: 500).
	direction := 0 @ 0.
	speed := 3.
	radius := 14! !

!AgarioPlayer methodsFor: 'initialization' stamp: 'MathiasKegelmann 9/22/2018 17:50'!
move 
		position := position + (direction * speed). ! !

!AgarioPlayer methodsFor: 'accesing' stamp: 'MathiasKegelmann 9/22/2018 18:05'!
position
	^position! !

!AgarioPlayer methodsFor: 'accesing' stamp: 'MathiasKegelmann 9/22/2018 18:05'!
radius
	^radius! !
